SystemOrganization addCategory: #'Cache-Scripting-Experiments'!
SystemOrganization addCategory: 'Cache-Scripting-Experiments-Patterns'!

TestCase subclass: #CachingVariableSanityTest
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!CachingVariableSanityTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 17:59'!
testEquality

	self assert: (TempCachingVariable new 
							class: Object 
							name: 'someCache' 
							method: '#Object>>someMethod' ) = (TempCachingVariable new 
																			class: Object 
																			name: 'someCache' 
																			method: '#Object>>someMethod' ).
	self deny: (TempCachingVariable new 
							class: Object 
							name: 'someCache' 
							method: '#Object>>someMethod' ) = (TempCachingVariable new 
																			class: Object 
																			name: 'someCache' 
																			method: '#Object>>someMethod2' )
	! !

!CachingVariableSanityTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 18:12'!
testImportExport

	collection := OrderedCollection new.

	1 to: 10 do: [: i | collection add: (TempCachingVariable new 
												class: Object 
												name: 'someCache' 
												method: '#Object>>someMethod' ) ].
											
	FLSerializer serialize: collection toFileNamed: self class name" , '-' , DateAndTime now asString" , '.FUEL'.
	collection := FLMaterializer materializeFromFileNamed: self class name" , '-' , DateAndTime now asString" , '.FUEL'.
	self assert: collection size = 10.
	self assert: collection asSet size = 1.									
	! !

!CachingVariableSanityTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 18:01'!
testSet

	collection := OrderedCollection new.

	1 to: 10 do: [: i | collection add: (TempCachingVariable new 
												class: Object 
												name: 'someCache' 
												method: '#Object>>someMethod' ) ].
	self assert: collection asSet size = 1.! !

Object subclass: #AnalysisASTGatherer
	instanceVariableNames: 'gatherBlock filterBlock results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments-Patterns'!

!AnalysisASTGatherer methodsFor: 'analyzing' stamp: 'GuillermoPolito 10/13/2015 19:30'!
analyzeNode: aNode
	
	(filterBlock value: aNode)
		ifTrue: [ results add: (gatherBlock value: aNode) ]! !

!AnalysisASTGatherer methodsFor: 'running' stamp: 'GuillermoPolito 10/13/2015 19:27'!
from: ast 
	
	ast acceptVisitor: self.
	^ results! !

!AnalysisASTGatherer methodsFor: 'accessing' stamp: 'GuillermoPolito 10/13/2015 19:27'!
gather: aBlockClosure 
	
	gatherBlock := aBlockClosure! !

!AnalysisASTGatherer methodsFor: 'initialize - release' stamp: 'GuillermoPolito 10/13/2015 19:35'!
initialize
	super initialize.
	results := Set new.! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:40'!
visitArgumentNode: aNode

	self analyzeNode: aNode! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:50'!
visitArrayNode: aNode
	
	self analyzeNode: aNode.
	aNode statements do: [ :each | each acceptVisitor: self ]! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:34'!
visitAssignmentNode: aRBAssignmentNode 
	
	self analyzeNode: aRBAssignmentNode.
	aRBAssignmentNode variable acceptVisitor: self.
	aRBAssignmentNode value acceptVisitor: self.! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:38'!
visitBlockNode: aNode

	self analyzeNode: aNode.
	aNode body acceptVisitor: self! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:52'!
visitCascadeNode: aNode
	
	self analyzeNode: aNode.
	aNode messages do: [:each | each acceptVisitor: self ]! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:34'!
visitGlobalNode: aRBGlobalNode 
	
	self analyzeNode: aRBGlobalNode! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:40'!
visitInstanceVariableNode: aNode

	self analyzeNode: aNode! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:49'!
visitLiteralArrayNode: aNode
	
	self analyzeNode: aNode! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:35'!
visitLiteralNode: aRBLiteralValueNode 
	
	self analyzeNode: aRBLiteralValueNode! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:37'!
visitMessageNode: aNode
	
	self analyzeNode: aNode.
	aNode receiver acceptVisitor: self.
	aNode arguments do: [ :each | each acceptVisitor: self ]! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:29'!
visitMethodNode: aRBMethodNode 
	
	self analyzeNode: aRBMethodNode.
	aRBMethodNode body acceptVisitor: self! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:32'!
visitNode: aRBAssignmentNode 
	self shouldBeImplemented.! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:36'!
visitReturnNode: aNode
	
	self analyzeNode: aNode.
	aNode value acceptVisitor: self! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:38'!
visitSelfNode: aNode

	self analyzeNode: aNode! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:33'!
visitSequenceNode: aSequenceNode 
	
	self analyzeNode: aSequenceNode.
	aSequenceNode statements
		do: [:each | each acceptVisitor: self ]! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:50'!
visitSuperNode: aNode
	
	self analyzeNode: aNode! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:39'!
visitTemporaryNode: aNode
	
	self analyzeNode: aNode! !

!AnalysisASTGatherer methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 19:50'!
visitVariableNode: aNode
	
	self analyzeNode: aNode! !

!AnalysisASTGatherer methodsFor: 'accessing' stamp: 'GuillermoPolito 10/13/2015 19:27'!
where: aBlockClosure 
	
	filterBlock := aBlockClosure! !

Object subclass: #CacheCollection
	instanceVariableNames: 'imageInfo collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

CacheCollection subclass: #AnalysisInformallyAnotatedCaches
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

AnalysisInformallyAnotatedCaches subclass: #AnalysisInformallyAnotatedBuffers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!AnalysisInformallyAnotatedBuffers methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/22/2015 13:08'!
isInformallyAnnotated: iv

	^ (iv includesSubstring: 'buf' caseSensitive: false) ! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/22/2015 12:58'!
cachesForClass: aClass

	^ aClass instanceVariables ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | self isInformallyAnnotated: iv]) asOrderedCollection ]
! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/22/2015 13:00'!
cachesForClassInClassVars: aClass

	^ aClass classVarNames ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | self isInformallyAnnotated: iv ]) asOrderedCollection ]
! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/22/2015 13:00'!
cachesForMethod: aMethod

	^ aMethod tempNames ifNil: [ {  } ] ifNotNilDo: 
		[:temps | (temps select: [ :temp | self isInformallyAnnotated: temp]) asOrderedCollection ]! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 17:54'!
checkForClassVarsIn: class

	class isMeta ifFalse: [
				(self cachesForClassInClassVars: class)
					ifNotEmptyDo: [:caches | 
							caches do: [ :cache | collection add: (SharedCachingVariable new class: class  name: cache ) ]]
			]! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 17:54'!
checkForIVsIn: class

	(self cachesForClass: class) ifNotEmptyDo: [:caches | 
		caches do: [ :cache |
				|cachingVar| 
				class isMeta
					ifTrue: [ cachingVar := ClassSideCachingVariable new class: class name: cache  ]
					ifFalse: [ cachingVar := InstanceSideCachingVariable new class: class name: cache  ]. 
					collection add: cachingVar ]].! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 17:54'!
checkForTempsIn: class

	class methods do: [ :method |
				(self cachesForMethod: method) 
					ifNotEmptyDo: [:caches | 
						caches do: [ :cache | collection add: (TempCachingVariable new class: method methodClass name: cache method: method ) ]]
				]! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 17:37'!
gatherSet

	ProtoObject allSubclasses do: [ :class |
		class package ~= self class package ifTrue: [   
			self checkForIVsIn: class. "both instance side and class side for metaclasses"
			self checkForClassVarsIn: class.
			self checkForTempsIn: class.
		]
	].
	! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/22/2015 13:04'!
isInformallyAnnotated: iv

	^ (iv includesSubstring: 'cach' caseSensitive: false) 
		"[ (iv includesSubstring: 'buf' caseSensitive: false) ]"! !

!CacheCollection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 14:47'!
importFromFuel: aFileName

	^ FLMaterializer materializeFromFileNamed: aFileName.
	! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 18:07'!
collection

	^ collection! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 17:55'!
collectionAsSet

	^ collection asSet "has already removed duplicates -- and avoids problems when doing collect: and counting results"! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 19:01'!
exportToFuel

	FLSerializer serialize: self toFileNamed: self class name" , '-' , DateAndTime now asString" , '.FUEL'.! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 11:11'!
gatherProcessAndExport

	self gatherSet postProcessing exportToFuel.! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:02'!
gatherSet

	self subclassResponsibility ! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 18:10'!
hasDuplicates

	^ (collection size = self collection asSet size) not! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 11:22'!
imageInfo

	^ imageInfo ! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 17:56'!
initialize

	super initialize.
	collection := OrderedCollection new.
	imageInfo := ImageInfo new.! !

!CacheCollection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 17:54'!
postProcessing

	collection do: [ :cachingVariable | cachingVariable postProcessing ]! !

CacheCollection subclass: #CaseStudySystemWide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

CacheCollection subclass: #ValidationGlobalStateCaches
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

Object subclass: #CachePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!CachePattern commentStamp: 'GuillermoPolito 10/13/2015 17:41' prior: 0!
pattern := LazyInitializePattern new.
accessOnly := Smalltalk allClasses gather: [ :class | pattern accessOnlyInClass: class ].
accessAndInvalidate := Smalltalk allClasses gather: [ :class | pattern accessAndInvalidateInClass: class ].

accessOnly size "1206"
accessAndInvalidate size "201".

pattern := MethodMemoizationPattern new.
mmaccessOnly := Smalltalk allClasses gather: [ :class | pattern accessOnlyInClass: class ].
mmaccessAndInvalidate := Smalltalk allClasses gather: [ :class | pattern accessAndInvalidateInClass: class ].

mmaccessOnly size."39"
mmaccessAndInvalidate size."15"

pattern := LazyDictionaryFillingPattern new.
dfaccessOnly := Smalltalk allClasses gather: [ :class | pattern accessOnlyInClass: class ].
dfaccessAndInvalidate := Smalltalk allClasses gather: [ :class | pattern accessAndInvalidateInClass: class ].

dfaccessOnly size."79"
dfaccessAndInvalidate size. "0"!

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:59'!
accessAndInvalidateInClass: aClass

	^ self searchInClass: aClass using: [ :variable :class |
		(self existAccessPatternOfVar: variable inClass: class)
			and: [ self existInvalidationPatternOfVar: variable inClass: class ] ]! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:58'!
accessOnlyInClass: aClass

	^ self searchInClass: aClass using: [ :variable :class |
		self existAccessPatternOfVar: variable inClass: class ]! !

!CachePattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 12:51'!
existAccessPatternOfVar: aVariable inClass: aClass! !

!CachePattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 12:51'!
existFillingPatternOfVar: aVariable inClass: aClass! !

!CachePattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 12:51'!
existInvalidationPatternOfVar: aVariable inClass: aClass! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:49'!
isCacheSlot: aVariable inClass: aClass
		
	^ (self isExplicitlyNilled: aVariable inClass: aClass)
		and: [ self isLazyInitialize: aVariable inClass: aClass ]! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:49'!
isExplicitlyNilled: aVariable inClass: aClass
	
	^ (self methodsIn: aClass) anySatisfy: [ :method |
		(RBParseTreeSearcher treeMatching: aVariable name, ' := nil ' in: method ast) notNil ].! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:49'!
isLazyInitialize: aVariable inClass: aClass
	
	^ (self methodsIn: aClass) anySatisfy: [ :m |
		(RBParseTreeSearcher treeMatching: aVariable name, ' ifNil: [ ', aVariable name ,' := ``@.S ] ' in: m ast) notNil ].! !

!CachePattern methodsFor: 'testing' stamp: 'PatternCacheDetector2 10/8/2015 12:49'!
methodsIn: aClass
	
	^ aClass theNonMetaClass methods , aClass theMetaClass methods! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:49'!
searchInAllClasses

	^ Smalltalk allClasses gather: [ :each |
		self searchInClass: each ].! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:54'!
searchInAllClassesFull: aBoolean

	^ Smalltalk allClasses gather: [ :each |
		self searchInClass: each full: aBoolean ].! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:54'!
searchInClass: aClass 
	
	^ self searchInClass: aClass full: true! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:53'!
searchInClass: aClass full: aBoolean
	
	^ (aClass slots, aClass theMetaClass slots , aClass classVariables)
		select: [ :slot | self isCacheSlot: slot inClass: aClass full: aBoolean ]
		thenCollect: [ :slot | { aClass . slot } ]! !

!CachePattern methodsFor: 'searching' stamp: 'PatternCacheDetector2 10/8/2015 12:57'!
searchInClass: aClass using: aBlock
	
	^ (aClass slots, aClass theMetaClass slots , aClass classVariables)
		select: [ :slot | aBlock value: slot value: aClass ]
		thenCollect: [ :slot | { aClass . slot } ]! !

CachePattern subclass: #LazyDictionaryFillingPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!LazyDictionaryFillingPattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 13:11'!
existAccessPatternOfVar: aVariable inClass: aClass
	
	^ (self methodsIn: aClass) anySatisfy: [ :method |
			(RBParseTreeSearcher
				treeMatching: aVariable name, ' at: ``@anything ifAbsentPut: ``@anotherAnything'
				in: method ast) notNil ].! !

!LazyDictionaryFillingPattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 13:11'!
existFillingPatternOfVar: aVariable inClass: aClass
	
	^ self existAccessPatternOfVar: aVariable inClass: aClass ! !

!LazyDictionaryFillingPattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 13:11'!
existInvalidationPatternOfVar: aVariable inClass: aClass

	^ (self methodsIn: aClass) anySatisfy: [ :method |
		(RBParseTreeSearcher treeMatching: aVariable name, ' removesKey: ``@anything ' in: method ast) notNil ].! !

CachePattern subclass: #LazyInitializePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!LazyInitializePattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 12:52'!
existAccessPatternOfVar: aVariable inClass: aClass
	
	^ (self methodsIn: aClass) anySatisfy: [ :m |
		(RBParseTreeSearcher treeMatching: aVariable name, ' ifNil: [ ', aVariable name ,' := ``@.S ] ' in: m ast) notNil ].! !

!LazyInitializePattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 12:53'!
existFillingPatternOfVar: aVariable inClass: aClass
	
	^ self existAccessPatternOfVar: aVariable inClass: aClass ! !

!LazyInitializePattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 12:52'!
existInvalidationPatternOfVar: aVariable inClass: aClass

	^ (self methodsIn: aClass) anySatisfy: [ :method |
		(RBParseTreeSearcher treeMatching: aVariable name, ' := nil ' in: method ast) notNil ].! !

CachePattern subclass: #MethodMemoizationPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!MethodMemoizationPattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 13:08'!
existAccessPatternOfVar: aVariable inClass: aClass
	
	^ (self methodsIn: aClass) anySatisfy: [ :method |
			(RBParseTreeSearcher
				treeMatching: aVariable name, ' ifNotNil: [ ^ ', aVariable name, ']'
				in: method ast) notNil ].! !

!MethodMemoizationPattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 13:09'!
existFillingPatternOfVar: aVariable inClass: aClass
	
	^ (self methodsIn: aClass) anySatisfy: [ :method |
			(RBParseTreeSearcher
				treeMatching: aVariable name, ' := ``@something '
				in: method ast) notNil ].! !

!MethodMemoizationPattern methodsFor: 'detection' stamp: 'PatternCacheDetector2 10/8/2015 13:08'!
existInvalidationPatternOfVar: aVariable inClass: aClass

	^ (self methodsIn: aClass) anySatisfy: [ :method |
		(RBParseTreeSearcher treeMatching: aVariable name, ' := nil ' in: method ast) notNil ].! !

Object subclass: #CachingVariable
	instanceVariableNames: 'hash packageGroup package class name methods testClass values selectors protocols exposable patterns properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!CachingVariable commentStamp: 'NickPapoulias 10/23/2015 12:51' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State a one line summary. For example, "I represent a paragraph of text".

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	class: <Symbol> Class that contains the cache. Scope is determined in subclasses. 
			eg #SystemDictionary
	exposable: <Boolean> If it is returned directly, or as a msg-send with the cache directly as the receiver (heuristic) 
			eg true
	methods: <OrderedCollection> Methods that have VariableNode with the cache. 
			eg. an OrderedCollection(#'SystemDictionary>>#flushClassNameCache' #'SystemDictionary>>#nonClassNames' #'SystemDictionary>>#fillCaches') 
	name:	<Symbol> The name of the cache
			eg. #cachedNonClassNames
	package: <Symbol>  The package of the containing class
			eg.  #System-Support
	packageGroup: <Symbol> The package group of the containing class
			eg. #System
	patterns: <OrderedCollection> Todo Guille:
			eg. (probably smth like) an asOrderedCollection (#'SystemDictionary>>#flushClassNameCache' -> #flushing-pattern)) 
	protocols: <Set> The statically retrieved protocols corresponding to selectors directly sent to the cache: 
			eg.  a Set(#testing)
	selectors:	<Set> Selectors that were send directly to the cache
			eg.  a Set(#ifNil:)
	testClass:	<Symbol> The corresponding testClass if it exists
			eg.  #SystemDictionaryTest
	values:	<Set> The values directly assigned as literal or as Global new 
			eg. a Set(nil)


    Implementation Points!

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 19:54'!
= anObject

	^ ((self class = anObject class) and: [ class = anObject cacheClass ]) and: [ name = anObject name ]! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/20/2015 17:36'!
cacheClass
	^ class! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 11/8/2015 19:47'!
class: aClass name: aName

	name := aName asSymbol. "just to be sure"
	class := aClass name asSymbol.
	package := aClass package name asSymbol.
	packageGroup := (package asString findTokens: '-') first asSymbol.
	properties := Dictionary new.
	! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:44'!
constantStringOfASTNode: aNode

	aNode isAssignment ifTrue: [ ^ self constantStringOfASTNode: aNode value ].
	(aNode isLiteralNode and: [aNode value = nil]) ifTrue: [ ^ 'nil' ].
	^ 'notNil'! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 14:43'!
hash

	^ hash ifNil: [ hash := (self class hash bitXor: class hash) bitXor: name hash]! !

!CachingVariable methodsFor: 'testing-ast' stamp: 'GuillermoPolito 11/17/2015 12:51'!
isMessageReceiver: ast
		
	^ ast parent isMessage and: [ ast parent receiver = ast ]! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/22/2015 12:45'!
liveClass

	^ (class includesSubstring: ' class') "metaclass"
			ifTrue: [ (Smalltalk globals at: ((class findTokens: ' ') first) asSymbol) class ]
			ifFalse: [ (Smalltalk globals at: class asSymbol) ].
		! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 13:51'!
liveClassFor: aClassPrintString

	^ (aClassPrintString includesSubstring: ' class') "metaclass"
			ifTrue: [ (Smalltalk globals at: ((aClassPrintString findTokens: ' ') first) asSymbol) class ]
			ifFalse: [ (Smalltalk globals at: aClassPrintString asSymbol) ].
		! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 13:51'!
liveMethods

	^ methods collect: [ :method | |tokens |
		tokens := method asString findTokens: '>>#'.
		(self liveClassFor: tokens first) >> tokens last asSymbol]! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/20/2015 17:36'!
methods
	^ methods! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/20/2015 17:37'!
name
	^ name! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/22/2015 13:19'!
package
	^ package! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/22/2015 13:19'!
packageGroup
	^ packageGroup! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/22/2015 13:23'!
patterns
	^ patterns! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:34'!
postProcessing

	"calculate values, selectors and patterns"
	self postProcessingTestClass.
	self postProcessingMethods.
	self postProcessingValues.
	self postProcessingSelectors.
	self postProcessingProtocols. "less concrete in static analysis"
	self postProcessingExposable.
	self postProcessingAggregate.
	self postProcessingProper.
	self postProcessingUsesNil.
	self postProcessingMonoMorphic.
	self postProcessingPatterns.
	self postProcessingUsages.! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/8/2015 19:32'!
postProcessingAggregate

	| aggregateClasses aggregateSelectors |
	aggregateClasses := Collection allSubclasses.
	aggregateClasses add: Collection.
	aggregateSelectors := aggregateClasses flatCollect: [ :cl | cl methods collect: [ :method | method selector ] ]. 
	aggregateClasses := (aggregateClasses collect: [ :cl | cl name asSymbol ]) asSet.
	^ properties 
		at: #aggregate 
		put: (((values intersection: aggregateClasses) isEmpty not)
					or: [ (selectors intersection: aggregateSelectors) isEmpty not ]).
! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/8/2015 18:05'!
postProcessingExposable

	self liveMethods do: [ :method | 
		method ast nodesDo: [ :node |  
			((node isReturn and: [ node value isVariable ]) and: [ node value name = name ])
				ifTrue: [ ^ properties at: #exposable put: true ].	
			(((node isReturn and: [ node value isMessage ]) and:  [ node value receiver isVariable ]) and: [ node value receiver name = name ]) "heuristic"
				ifTrue: [ ^ properties at: #exposable put: true ]
		]	
	].
	^ properties at: #exposable put: false! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 13:52'!
postProcessingMethods

	"calculate values, selectors and patterns"
	methods := (self liveClass methods asOrderedCollection 
						select: [:method | 
							(method variableNodes select: [ :node | node name = name ]) isEmpty not ])
						collect: [ :method | method printString asSymbol ]
	! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/10/2015 10:43'!
postProcessingMonoMorphic

	"we can include here selectors"

	(values includes: #UndefinedObject)
		ifTrue: [ ^ properties at: #monomorphic put: (values size <= 2) ]
		ifFalse: [ ^ properties at: #monomorphic put: (values size <= 1) ] ! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/10/2015 12:03'!
postProcessingPatterns

	|allPatternClasses|
	
	allPatternClasses := CachePattern allSubclasses collect: [ :cl | cl name asSymbol ].
	patterns := Dictionary new.
	allPatternClasses do: [ :symbol | 
		|detectionSelectors|
		detectionSelectors := ((Smalltalk globals at: symbol) 
			methods select: [ :method | method protocol = 'detection' ])
			collect: [ :method | method selector ].
		patterns at: symbol put: Dictionary new.
		detectionSelectors
			do: [ :selector | 
					(patterns at: symbol) 
						at: selector
						put: ((Smalltalk globals at: symbol) new
									perform: selector 
									withArguments: { Slot named: name asSymbol . self liveClass }).
				]
	].
	! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/8/2015 20:19'!
postProcessingProper

	| cacheNamedClasses aggregateClasses aggregateSelectors properSelectors |
	aggregateClasses := Collection allSubclasses.
	aggregateClasses add: Collection.
	aggregateSelectors := aggregateClasses flatCollect: [ :cl | cl methods collect: [ :method | method selector ] ]. 
	aggregateClasses := (aggregateClasses collect: [ :cl | cl name asSymbol ]) asSet.
	
	
	cacheNamedClasses := (ProtoObject allSubclasses select: [ :cl |
		(cl package ~= self class package) and: [    
			cl isMeta not and: 
			[cl name asString includesSubstring: 'cach' caseSensitive: false]]
	]).

	properSelectors := cacheNamedClasses flatCollect: [ :cl | cl methods collect: [ :method | method selector ] ]. 
	properSelectors := properSelectors select: [ :selector | (aggregateSelectors includes: selector) not ].
	cacheNamedClasses := cacheNamedClasses collect: [:cl | cl name asSymbol].
	^ properties 
		at: #proper 
		put: (((values intersection: cacheNamedClasses) isEmpty not)
					or: [(selectors intersection: properSelectors) isEmpty not])! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/22/2015 12:52'!
postProcessingProtocols

	protocols := (selectors flatCollect: [:selector | 
		(SystemNavigation default allImplementorsOf: selector) 
			collect: [ :rgMethod | rgMethod protocol ]  ]) asSet! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/22/2015 12:53'!
postProcessingSelectors

	|nodes|

	nodes := ((self liveMethods flatCollect: [:method | method variableNodes ])
		select: [ :node | node name = name ])
		select: [ :node | node parent isMessage].
		
	selectors := (nodes collect: [ :node | node parent selector ]) asSet.
	
	! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/27/2015 13:57'!
postProcessingTestClass

	|lookFor|

	lookFor := (self liveClass theNonMetaClass asString , 'Test') asSymbol.
	(Smalltalk globals keys includes: lookFor)
		ifTrue: [ testClass := lookFor ]
		ifFalse: [  
			(self liveClass inheritsFrom: TestCase)
				ifTrue: [ testClass := self liveClass name asSymbol ]
		]! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:43'!
postProcessingUsages

	| methodUsers usages |
	methodUsers := self usingMethods.
	usages := methodUsers gather: [ :each |
		AnalysisASTGatherer new
			gather: [ :ast | ast parent ];
			where: [ :ast | 
				ast isVariable
					and: [ ast name = name
						and: [ 
							(self isMessageReceiver: ast)
								or: [ ast parent isMessage not ] ] ] ];
			from: each ast ].
	
	usages := (usages collect: [ :each | self stringKeyOfUsageAST: each ]) asSet asArray.
	
	^ properties 
		at: #usages 
		put: usages! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/10/2015 10:50'!
postProcessingUsesNil
	| nilSelectors |
	nilSelectors := UndefinedObject methods collect: [ :method | method selector ].
	^ properties 
		at: #usesNil 
		put: ((values includes: #UndefinedObject)
					or: [(selectors intersection: nilSelectors) isEmpty not]).

! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/8/2015 20:51'!
postProcessingValues

	|nodes|

	nodes := ((self liveMethods flatCollect: [:method | method assignmentNodes ])
		select: [ :assignNode | assignNode variable name = name ])
		collect: [ :assignNode | assignNode value].
	values := OrderedCollection new.
	values addAll: ((nodes select: [:node | node isLiteralNode ]) collect: [ :node | node value class name ]).
	values addAll: 
		(((nodes select: [:node | node isMessage ]) 
			select: [ :node | (node receiver isVariable and: [ node receiver isGlobal ]) and: [node selector = #new] ])
			collect: [:node | node receiver name]).
	values := values asSet! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/8/2015 18:05'!
properties

	^ properties! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/22/2015 13:22'!
protocols
	^ protocols! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/22/2015 13:22'!
selectors
	^ selectors! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:44'!
stringKeyOfUsageAST: aUsagePattern

	aUsagePattern isMessage
		ifTrue: [ ^ aUsagePattern selector ].
	
	aUsagePattern isAssignment
		ifTrue: [ ^ ('":=', (self constantStringOfASTNode: aUsagePattern value), '"') asSymbol ].

	^ aUsagePattern printString asSymbol! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/22/2015 13:19'!
testClass
	^ testClass! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/22/2015 13:22'!
values
	^ values! !

CachingVariable subclass: #ClassSideCachingVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!ClassSideCachingVariable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:53'!
usingMethods

	^ (self liveClass classSide slotNamed: name) usingMethods! !

CachingVariable subclass: #InstanceSideCachingVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!InstanceSideCachingVariable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:51'!
usingMethods

	^ (self liveClass instanceSide slotNamed: name) usingMethods! !

CachingVariable subclass: #SharedCachingVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!SharedCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 13:48'!
postProcessingMethods

	super postProcessingMethods.
	methods ifNil: [ methods := OrderedCollection new ].
	methods addAll: ((self liveClass class methods "class side"
						select: [:method | 
							(method variableNodes select: [ :node | node name = name ]) isEmpty not ])
						collect: [ :method | method printString asSymbol ]).! !

!SharedCachingVariable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:51'!
usingMethods

	^ (self liveClass classPool associationAt: name) usingMethods! !

CachingVariable subclass: #TempCachingVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 19:55'!
= anObject

	^ (super = anObject) and: [ methods = anObject methods ]! !

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2015 18:06'!
class: aClass name: aName method: aMethod

	super class: aClass name: aName.
	methods := { aMethod printString asSymbol } asOrderedCollection.! !

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2015 14:42'!
hash
	
	^ hash ifNil: [ hash := super hash bitXor: methods first hash ] "some spookey bug with fuel here check"! !

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 15:58'!
postProcessingMethods
	
	"nothing to do only one method accesses me"! !

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:39'!
usingMethods

	^ methods collect: [ :each | Compiler evaluate: each ]! !

Object subclass: #ImageInfo
	instanceVariableNames: 'version packagesToNumberOfClasses packageGroupsToNumberOfClasses cacheNamedClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!ImageInfo methodsFor: 'accessing' stamp: 'NickPapoulias 11/8/2015 19:22'!
cacheNamedClasses
	^ cacheNamedClasses! !

!ImageInfo methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/8/2015 20:08'!
initialize

	version := SystemVersion current asString.
	packagesToNumberOfClasses := (ProtoObject allSubclasses 
		collect: [ :class | class package name asSymbol -> class package classes size ]) asSet asDictionary.
	packagesToNumberOfClasses removeKey: self class package name asSymbol. "don't count the experiment package"
	packageGroupsToNumberOfClasses := Dictionary new.
	packagesToNumberOfClasses keysAndValuesDo:
		 [ :package :numberOfClasses | 
			|before packageGroup|
			packageGroup := (package asString findTokens: '-') first asSymbol.
			before := (packageGroupsToNumberOfClasses 
				at: packageGroup
				ifAbsentPut: 0).
			packageGroupsToNumberOfClasses 
				at: packageGroup
			  	put: before + numberOfClasses.
		].
	cacheNamedClasses := (ProtoObject allSubclasses select: [ :class |
		(class package ~= self class package) and: [     
			class isMeta not and: 
				[class name asString includesSubstring: 'cach' caseSensitive: false]]
	]) collect: [:class | class name asSymbol].! !

!ImageInfo methodsFor: 'accessing' stamp: 'NickPapoulias 10/28/2015 18:29'!
packageGroupsToNumberOfClasses
	^ packageGroupsToNumberOfClasses! !

!ImageInfo methodsFor: 'accessing' stamp: 'NickPapoulias 10/28/2015 18:29'!
packageGroupsToNumberOfClasses: anObject
	packageGroupsToNumberOfClasses := anObject! !

!ImageInfo methodsFor: 'accessing' stamp: 'NickPapoulias 10/28/2015 18:29'!
packagesToNumberOfClasses
	^ packagesToNumberOfClasses! !

!ImageInfo methodsFor: 'accessing' stamp: 'NickPapoulias 10/28/2015 18:29'!
packagesToNumberOfClasses: anObject
	packagesToNumberOfClasses := anObject! !

!ImageInfo methodsFor: 'accessing' stamp: 'NickPapoulias 10/28/2015 18:29'!
version
	^ version! !

!ImageInfo methodsFor: 'accessing' stamp: 'NickPapoulias 10/28/2015 18:29'!
version: anObject
	version := anObject! !

Object subclass: #NamedCachePatternDetector
	instanceVariableNames: 'cacheVariables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments-Patterns'!

!NamedCachePatternDetector methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:46'!
importFromFuel: aFuelFile

	| patternCalculator |
	cacheVariables := (AnalysisInformallyAnotatedCaches importFromFuel: aFuelFile) collectionAsSet.
	patternCalculator := SimilarMessageSendCalculator new.
	self visitPatterns: patternCalculator.
	patternCalculator writeReportInto: 'cachesCategoryMultipleKeys.txt' filter: [:each | each key size > 1 ].! !

!NamedCachePatternDetector methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/17/2015 12:31'!
patterns

	^ cacheVariables collect: [ :variable |
		self usagesOf: variable ]! !

!NamedCachePatternDetector methodsFor: 'helpers' stamp: 'GuillermoPolito 11/17/2015 12:44'!
usagesOf: aVariableObject
	
	^ aVariableObject properties at: #usages! !

!NamedCachePatternDetector methodsFor: 'visiting' stamp: 'GuillermoPolito 11/17/2015 12:54'!
visitPatterns: aPatternCalculator 
	
	self patterns do: [ :each | aPatternCalculator visitPattern: each ]! !

Object subclass: #PatternTable
	instanceVariableNames: 'matrix variables patterns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments-Patterns'!

!PatternTable methodsFor: 'adding' stamp: 'GuillermoPolito 11/6/2015 16:03'!
addPattern: aCollection toVariable: variable
	
	matrix
		at: (self variableIndex: variable)
		at: (self patternIndex: aCollection)
		put: true! !

!PatternTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/6/2015 16:06'!
initMatrixRows: anInteger values: anInteger2 
	
	matrix := Matrix rows: anInteger columns: anInteger2 element: false! !

!PatternTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/6/2015 16:06'!
patternIndex: aCollection 
	
	patterns ifNil: [ patterns := Dictionary new ].
	^ patterns
		at: aCollection 
		ifAbsentPut: [ patterns size + 1 ].! !

!PatternTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/6/2015 16:11'!
rowsFor: aTemporaryVariable 
	
	^ matrix atRow: (self variableIndex: aTemporaryVariable)! !

!PatternTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/6/2015 16:05'!
variableIndex: anInstanceVariableSlot 
	
	variables ifNil: [ variables := Dictionary new ].
	^ variables
		at: anInstanceVariableSlot
		ifAbsentPut: [ variables size + 1 ].! !

!PatternTable methodsFor: 'accessing' stamp: 'GuillermoPolito 11/6/2015 16:10'!
variables
	^ variables keys! !

Object subclass: #SimilarMessageSendCalculator
	instanceVariableNames: 'sendCombinations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments-Patterns'!

!SimilarMessageSendCalculator commentStamp: 'GuillermoPolito 10/13/2015 23:28' prior: 0!
messageSendSimilarities := SimilarMessageSendCalculator new.

detector := NamedCacheDetector new.
detector collectPatterns.
detector visitPatterns: messageSendSimilarities.

messageSendSimilarities writeReportInto: '../../papers/caches-oops-2016/cachesCategoryMultipleKeys.txt' filter: [:each | each key size > 1 ].!

!SimilarMessageSendCalculator methodsFor: 'initialization' stamp: 'GuillermoPolito 10/13/2015 20:07'!
initialize
	super initialize.
	sendCombinations := Dictionary new.! !

!SimilarMessageSendCalculator methodsFor: 'accessing' stamp: 'GuillermoPolito 10/13/2015 20:46'!
sendCombinations
	^ sendCombinations! !

!SimilarMessageSendCalculator methodsFor: 'visiting' stamp: 'GuillermoPolito 11/17/2015 12:54'!
visitPattern: anUsagePattern
	
	anUsagePattern combinations do: [ :each | | combination |
			combination := each sorted asArray.
			sendCombinations at: combination ifAbsentPut: [ Set new ].
			(sendCombinations at: combination)
				add: anUsagePattern ]! !

!SimilarMessageSendCalculator methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 21:07'!
writeReportInto: aFileName

	| str |
	str := aFileName asFileReference writeStream.
	(((self sendCombinations associations collect: [ :each | each value size -> each key ])
		sorted: [ :each1 :each2 | each1 key > each2 key ])) do: [ :each | 
			str
				nextPutAll: (each key asString padLeftTo: 4);
				nextPutAll: '   ';
			 	nextPutAll: each value asString;
				cr]! !

!SimilarMessageSendCalculator methodsFor: 'visiting' stamp: 'GuillermoPolito 10/13/2015 22:31'!
writeReportInto: aFileName filter: aBlock

	| str |
	str := aFileName asFileReference writeStream.
	(((self sendCombinations associations select: aBlock thenCollect: [ :each | each value size -> each key ])
		sorted: [ :each1 :each2 | each1 key > each2 key ])) do: [ :each | 
			str
				nextPutAll: (each key asString padLeftTo: 4);
				nextPutAll: '   ';
			 	nextPutAll: each value asString;
				cr]! !

!TemporaryVariable methodsFor: '*Cache-Scripting-Experiments' stamp: 'GuillermoPolito 11/17/2015 12:32'!
usingMethods
	
	^ { method }! !
